package MDBean;

import org.jboss.ejb3.annotation.ResourceAdapter;

import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.inject.Inject;
import javax.jms.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import org.jboss.logging.Logger;


/**
 * Created by okalman on 7/15/14.
 */
@MessageDriven(name = "HelloWorldQueueMDB", activationConfig = {
        @ActivationConfigProperty(propertyName = "destination", propertyValue = "java:/test_topic"),
        @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Topic"),
        @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
        @ActivationConfigProperty(propertyName = "subscriptionDurability", propertyValue = "Durable"),
        @ActivationConfigProperty(propertyName = "subscriptionName", propertyValue = "neco")
}
)

@TransactionAttribute(TransactionAttributeType.REQUIRED)
public class MessageBeanBean implements MessageListener {
    private static final Logger LOG = Logger.getLogger(MessageBeanBean.class);

    QueueConnection c;
    QueueSession session;

    public MessageBeanBean() {
    }

    @Override
    public void onMessage(Message message){
        try {
            LOG.info("message received");
//            Context context = new InitialContext();
//            Queue q = (Queue)context.lookup("java:/jms/queue/OutQueue");
//            c = cf.createQueueConnection();
//            session = c.createQueueSession(true, Session.SESSION_TRANSACTED);
//            QueueSender sender = session.createSender(q);
//            sender.send(session.createTextMessage("received message"));
            LOG.info("message sent");}catch (Exception  e){

        }finally {
            try {
               // session.commit();
                if (c != null) c.close();
                if (session != null) session.close();
            }catch(Exception e){

            }

        }

    }
}
