package MDBean;

//
//import com.tibco.tibjms.TibjmsConnectionFactory;
//import com.tibco.tibjms.TibjmsQueueConnectionFactory;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;

import javax.jms.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.spi.InitialContextFactory;
import java.util.Properties;
import java.util.Vector;

/**
 * Created by okalman on 11/11/14.
 */
public class MDBTest {
    @Ignore
    @Test
    public void testOnMessage() throws Exception {
        String serverUrl = "tcp://tibco02.hosts.mwqe.eng.bos.redhat.com:7222";
        String queueName = "queue.sample";
        String userName = "";
        String password = "";

        Vector<Object> data = new Vector<Object>();
        data.add("Hello World!");



        System.out.println("Sending JMS message to server " + serverUrl + "...");

        final Properties env = new Properties();
            env.put(Context.INITIAL_CONTEXT_FACTORY, "com.tibco.tibjms.naming.TibjmsInitialContextFactory");
            env.put(Context.PROVIDER_URL, serverUrl);
            env.put("org.jboss.as.naming.lookup.by.string", true);
        Context context = new InitialContext(env);
        ConnectionFactory factory = (ConnectionFactory) context.lookup("CF");
    //    ConnectionFactory factory = new TibjmsConnectionFactory(serverUrl);
//        JMSContext ctx = factory.createContext(userName,password);
//        Assert.assertTrue(ctx.getSessionMode()== Session.AUTO_ACKNOWLEDGE);
        Connection connection = factory.createConnection();
        Session session = connection.createSession(false, javax.jms.Session.AUTO_ACKNOWLEDGE);

        // Use createQueue() to enable sending into dynamic queues.
        Destination destination = (Queue) context.lookup(queueName);
        MessageProducer sender = session.createProducer(destination);

			/* publish messages */
        for (int i = 0; i < data.size(); i++) {
            TextMessage jmsMessage = session.createTextMessage();
            String text = (String) data.elementAt(i);
            jmsMessage.setText(text);
            sender.send(jmsMessage);
            System.out.println("Sent message: " + text);
        }

        connection.close();



    }



}
